package cn.com.qmth.examcloud.task.api.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.api.commons.security.bean.User;
import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.task.dao.entity.ReportsComputeEntity;
import cn.com.qmth.examcloud.task.service.ReportsComputeService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("${$rmp.ctr.task}" + "reportsCompute")
public class ReportsComputeController extends ControllerSupport {


	@Autowired
	ReportsComputeService reportsComputeService;

	@ApiOperation(value = "终止计算任务")
	@PostMapping("/stopJob")
	public void stopJob(@RequestParam Long id){
		if (id == null) {
			throw new StatusException("1000001", "计算任务id不能为空");
		}
		User accessUser = getAccessUser();
		Long rootOrgId = accessUser.getRootOrgId();
		
		ReportsComputeEntity re=reportsComputeService.findById(id);
		
		if (re == null) {
			throw new StatusException("1000002", "计算任务不存在");
		}
		
		if(!rootOrgId.equals(re.getRootOrgId())) {
			throw new StatusException("1000003", "非法操作");
		}
		int ret=reportsComputeService.updateToStoping(re);
		if(ret==0) {
			throw new StatusException("1000004", "只能终止待处理和处理中的任务");
		}
	}


}
